=== client/deps/CMakeLists.txt ===
if (NOT TARGET pm3rrg_rdv4_amiibo)
  include(amiibo.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_cliparser)
  include(cliparser.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_hardnested)
  include(hardnested.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_id48)
  include(id48lib.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_jansson)
  include(jansson.cmake)
endif()
if ((NOT TARGET pm3rrg_rdv4_linenoise) AND (EXISTS ${PM3_ROOT}/client/deps/linenoise/))
  include(linenoise.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_lua)
  include(lua.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_mbedtls)
  include(mbedtls.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_reveng)
  include(reveng.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_tinycbor)
  include(tinycbor.cmake)
endif()
if (NOT TARGET pm3rrg_rdv4_whereami)
  include(whereami.cmake)
endif()
